
import './App.css';
import Layout from "./components/layout.js";
import MainImg from "./components/layout";
import {Provider, connect} from 'react-redux';
import {Header, Footer, catalogCard} from "./components/index"
import {BrowserRouter as Router, Route, Link, Switch, Redirect} from 'react-router-dom';
import createHistory from "history/createBrowserHistory";
import {createStore, combineReducers, applyMiddleware} from 'redux';
import thunk from 'redux-thunk';

function promiseReducer(state={}, action){
  if (action.type === 'PROMISE'){
      const { name="default", status, payload, error} = action
      if (status){
          return {
              ...state, [name]: {status, payload: (status === 'PENDING' && state[name] && state[name].payload) || payload, error}
          }
      }
  }
  return state;
}

export const store = createStore(combineReducers({promise: promiseReducer}), 
                        applyMiddleware(thunk))

function App() {
  return (
    <>
      <Provider store={store}>
      <Router history = {createHistory}>
        <Header/>
                  
        <MainImg/>

        <Footer/>
      </Router>
      </Provider>
    </>
  );
}

export default App;
