import {createStore, combineReducers, applyMiddleware} from 'redux';
import thunk from 'redux-thunk';
import {Provider, connect} from 'react-redux';


///reducer, где набор экшн.типов + функции.(если - то)
// Экшн промис + асинх диспатч.(копия)
//промис редюсер - копия
//комбайн редюсер, в нем обьект разных редьюсеров. 
//Распиоит на подобьекты, но экшены вместе. 
//аплаймидлВар(санк) чтобы скачивать данные
//стор.гетстейт принес обьект 1,03
//другая гкуэль - функция,, параметр - строка из сайтагкуэль
//параметры - то, что получаем(?). Засунуть внутрь функции(єкшн) в которой диспатч.


const getGQL = url => 
    (query, variables={}) => 
        fetch(url, 
            {method: 'POST', 
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                  ...(localStorage.authToken ? {Authorization: `Bearer ${localStorage.authToken}`} : {})
                },
                body: JSON.stringify({query,variables})})
        .then(res => res.json())

export const actionPromise = (name, promise) => {
    console.log(name);
    const actionPending = () => ({type: 'PROMISE', name, status: 'PENDING', payload: null, error: null})
    const actionResolved = payload => ({type: 'PROMISE', name, status: 'RESOLVED', payload, error: null})
    const actionRejected = error => ({type: 'PROMISE', name, status: 'REJECTED', payload:null, error})


    return async dispatch => {
        dispatch(actionPending())
        let payload
        try {
            payload = await promise
            dispatch(actionResolved(payload))
        }
        catch (e){
            dispatch(actionRejected(e))
        }
        return payload;
    }
}

function promiseReducer(state={}, action){
    if (action.type === 'PROMISE'){
        const { name="default", status, payload, error} = action
        if (status){
            return {
                ...state, [name]: {status, payload: (status === 'PENDING' && state[name] && state[name].payload) || payload, error}
            }
        }
    }
    return state;
}

const store = createStore(combineReducers({promise: promiseReducer}), 
                        applyMiddleware(thunk))


const gql = getGQL("http://shop-roles.asmer.fs.a-level.com.ua/graphql");

const catalogCard = () => {
    console.log(1);
    return async dispatch => {
        
        let categories = await dispatch(actionPromise("data", gql(`
            query categories {
                CategoryFind(query:"[{}]") {
                _id name 
                goods {name, price _id, images {url}}
                    image {
                        _id
                        createdAt
                        text               
                        originalFileName
                    }
                }
            }`, )))
        
        console.log(categories);
    }
}



store.subscribe(() => console.log(store.getState()))

// function catalogReducer(state = {}, action) {
//     if (action.type = "FIRSTVISIT") {
//         catalogCard();
//     } 
//     return state;
// };

//const store = createStore(reducer, {});

export default catalogCard;

